/* FILE: oc.h                    -*-Mode: c++-*-
 *
 *	The OOMMF Core extension public header file.
 *
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 1998/07/30 13:11:06 $
 * Last modified by: $Author: dgp $
 */

#ifndef _OC
#define _OC

/* Header containing macros and typedefs describing the platform */
#include "port.h"

/* Prototypes imported from other extensions and libraries */
#include "imports.h"

/* Prototypes of functions in this extension */
#include "functions.h"

/* Declarations of classes in this extension */
#include "autobuf.h"

/* End includes */     /* Optional directive to pimake */

/* Check that the Tcl header file matches the Tcl version
 * used in configuration (notably library selection).  Otherwise
 * a mismatch may lead to mysterious pointer problems (Segmentation
 * fault).
 */

#if (TCL_MAJOR_VERSION != CONFIG_TCL_MAJOR_VERSION) \
        || (TCL_MINOR_VERSION != CONFIG_TCL_MINOR_VERSION)
#error "tcl.h version mismatch"
#endif

// Support for un-patched Tcl 7.5
#ifndef TCL_PATCH_LEVEL
#define TCL_PATCH_LEVEL CONFIG_TCL_PATCH_LEVEL
#define Tcl_Free free
#endif

/* Prototypes for the routines defined in oc.cc */
int Oc_Main(int,char**);
int Oc_Init(Tcl_Interp *);
void Oc_SetUseTkFlag(int);
int Oc_RegisterCommand(Tcl_Interp*,const char*,Tcl_CmdProc*);
Tcl_Interp* Oc_GlobalInterpreter();

#endif /* _OC */
